; The GIMP script-fu 「Denim」 for GIMP2.6

(define (script-fu-denim width height color)
  (let* (
        (img (car (gimp-image-new 5 5 RGB)))
        (base (car (gimp-layer-new img 5 5 RGB-IMAGE "Denim" 100 NORMAL-MODE)))
        (old-fg (car (gimp-context-get-foreground)))
        (old-brush (car (gimp-context-get-brush)))
        (strokes 0) (bump-layer 0)
        )

  (gimp-image-undo-disable img)
    
  (gimp-image-add-layer img base 0)
  (gimp-edit-fill base WHITE-FILL)
  (gimp-context-set-brush "Circle (01)")
  (gimp-context-set-foreground '(0 0 0))
  (set! strokes (cons-array 4 'double))
  (aset strokes 0 (* 1 5))
  (aset strokes 1 (* 1 0))
  (aset strokes 2 (* 1 0))
  (aset strokes 3 (* 1 5))
  (gimp-pencil base 4 strokes)

  (plug-in-tile 1 img base 20 20 FALSE)
  (plug-in-tile 1 img base width height FALSE)

  (set! bump-layer (car (gimp-layer-copy base TRUE)))
  (gimp-image-add-layer img bump-layer 0)
  (gimp-layer-set-mode bump-layer OVERLAY-MODE)
  (gimp-layer-set-opacity bump-layer 20)

  (gimp-context-set-foreground color)
  (gimp-edit-fill base FOREGROUND-FILL)
  (plug-in-rgb-noise 1 img base FALSE FALSE 0.25 0.25 0.25 0.00)
  (plug-in-bump-map 1 img base bump-layer 135 40 3 0 0 0 0 TRUE FALSE 0)
  (gimp-image-flatten img)

  (gimp-context-set-foreground old-fg)
  (gimp-context-set-brush old-brush)
  (gimp-image-undo-enable img)
  (gimp-display-new img)

  )
)

(script-fu-register "script-fu-denim"
  "Denim..."
  "Make Denim Texture"
  "Small aids"
  "Small aids"
  "2008/10"
  ""
  SF-ADJUSTMENT _"Image width"  '(256 20 1000 1 10 0 1)
  SF-ADJUSTMENT _"Image height" '(256 20 1000 1 10 0 1)
  SF-COLOR      _"Color"        '(0 70 110) )

(script-fu-menu-register "script-fu-denim"
                         "<Image>/File/Create/Patterns")
